
; REM Rev a01


; REM 1086010, Electronic Pill Timer using 10F200 microprocessor

; 'ROMBASE 00H
; 'SHTINT  Timecnt     ' ram for TRM0 internal timer register


; RAMBASE 07H			' start address for ram area

SIGN	EQU	07H
SCRATCH	EQU	08H
FLAG	EQU	09H

; REM ************ copy this portion to declare statement section  ***********

Timecnt	EQU	0AH	; counter for number of timer intervals
Scratch	EQU	0BH	;
Timeblk	EQU	0CH	; loop coumter for counting 5 second increments
PortG	EQU	06H	;  address of port G
PORstr	EQU	111000B	;  initial startup state for output port
TimeX5	EQU	1	; 

; REM *************************************************************************



; embedded line of assembly code-

	        LIST    p=10F200       ; processor type 


; ROMBASE 00H		' start program exec. here POR

	ORG	00H


;  GOTO Initialize  

	GOTO	Initialize


; ROMBASE 70H        ' main program area in rom

	ORG	70H


Initialize	; initilize system


;     PORTCFG PortG,I0OO    ' configure the port for input and output

	MOVLW	 8
	TRIS	PortG


;     OUT PortG,1000B        ' output to off state, make sure driver transistor is in correct state

	MOVLW	1000B
	MOVWF	PortG


; DOCODE

    MOVLW   B'10000111'
    OPTION

; ENDCODE


Main	;


;     GOSUB SetHi

	CALL	SetHi


;     FOR Timecnt = 0 TO TimeX5

	MOVLW	0
	MOVWF	Timecnt
Elbl1


;         GOSUB Dly50ms

	CALL	Dly50ms


;     NEXT

	MOVLW	TimeX5
	SUBWF	Timecnt,0
	BTFSC	3,2
	GOTO	Elbl2
	INCF	Timecnt,1
	GOTO	Elbl1
Elbl2


;     GOSUB SetLo

	CALL	SetLo


;     FOR Timecnt = 0 TO TimeX5

	MOVLW	0
	MOVWF	Timecnt
Elbl3


;         GOSUB Dly50ms

	CALL	Dly50ms


;     NEXT

	MOVLW	TimeX5
	SUBWF	Timecnt,0
	BTFSC	3,2
	GOTO	Elbl4
	INCF	Timecnt,1
	GOTO	Elbl3
Elbl4


;     GOTO Main

	GOTO	Main


; END

	GOTO	Asmend
; 'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX   SUBROITINES    XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX


; ROMBASE 01H                     ' start of rom area for subroutines

	ORG	01H
; '......................................


Dly50ms	; Time delay of 50 milli sec


; DOCODE

        MOVLW   0x00     ; set W register to 0
        MOVWF    0x01    ; set TMR0 register to zero

; ENDCODE


Waitloop	;


; DOCODE

        MOVF 0x01, 0      ; move value of TMR0 register to W reg
        MOVWF Scratch   ; now move TMR0 value to variable Scratch

; ENDCODE


;     IF Scratch <> 200 THEN Waitloop   ' loop until time is up -> Endvalue is number of counts for time

	MOVLW	200
	SUBWF	Scratch,0
	BTFSS	3,2
	GOTO	Waitloop


; RETURN

	RETLW	0
; '.....................................


Do5sec	; MUSTANG


;    Timecnt = 0     ' make sure time count is set to zero

	MOVLW	0
	MOVWF	Timecnt


;     FOR Timecnt = 0 TO 100

	MOVLW	0
	MOVWF	Timecnt
Elbl5


;         GOSUB Dly50ms

	CALL	Dly50ms


;     NEXT

	MOVLW	100
	SUBWF	Timecnt,0
	BTFSC	3,2
	GOTO	Elbl6
	INCF	Timecnt,1
	GOTO	Elbl5
Elbl6


; RETURN

	RETLW	0
; '................................


SetLo	; set output port to low state


;    PortG = 0000B

	MOVLW	0000B
	MOVWF	PortG


; RETURN

	RETLW	0
; '......................................


SetHi	; set output port to high state


;    PortG = 1100B

	MOVLW	1100B
	MOVWF	PortG


; RETURN

	RETLW	0
; '**********************************************


Asmend
	GOTO	Asmend
	END
