
; REM Rev a00


; REM 1086010, Electronic Pill Timer using 10F200 microprocessor



; RAMBASE 10H         ' start address for ram area

SIGN	EQU	010H
SCRATCH	EQU	011H
FLAG	EQU	012H

; REM ************ copy this portion to declare statement section  ***********

Timecnt	EQU	013H	; counter for number of timer intervals
Scratch	EQU	014H	;
Timeblk	EQU	015H	; loop coumter for counting 5 second increments
PortG	EQU	06H	;  address of port G
PORstr	EQU	111000B	;  initial startup state for output port
TimeX1	EQU	10	;  set number of mulitples of 5 seconds, 1 + 5 sec, 5 = 25 sec.

; REM *************************************************************************



; embedded line of assembly code-

	        LIST    p=10F200       ; processor type 


; ROMBASE 00H		' start program exec. here POR

	ORG	00H


;  GOTO Initialize  

	GOTO	Initialize


; ROMBASE 70H        ' main program area in rom

	ORG	70H


Initialize	; initilize system


;     PORTCFG PortG,I0OO    ' configure the port for input and output

	MOVLW	 8
	TRIS	PortG


;     OUT PortG,1000B        ' output to off state, make sure driver transistor is in correct state

	MOVLW	1000B
	MOVWF	PortG


; DOCODE

    MOVLW   B'10000111'
    OPTION

; ENDCODE


Main	;


;     Scratch = INP(PortG)

	MOVF	PortG,0
	MOVWF	Scratch


;     ON Scratch  3 TRUE DO SetLo         

	BTFSC	Scratch,3
	CALL	SetLo


;     ON Scratch  3 FALSE DO SetHi        

	BTFSS	Scratch,3
	CALL	SetHi


;     FOR Timeblk = 1 TO TimeX1                    ' count the nubmer of desired 5 second intervals

	MOVLW	1
	MOVWF	Timeblk
Elbl1


;         GOSUB Do1sec                        

	CALL	Do1sec


;     NEXT

	MOVLW	TimeX1
	SUBWF	Timeblk,0
	BTFSC	3,2
	GOTO	Elbl2
	INCF	Timeblk,1
	GOTO	Elbl1
Elbl2


;     Scratch = INP(PortG)

	MOVF	PortG,0
	MOVWF	Scratch


;     ON Scratch  3 TRUE DO SetHi        

	BTFSC	Scratch,3
	CALL	SetHi


;     ON Scratch  3 FALSE DO SetLo       

	BTFSS	Scratch,3
	CALL	SetLo


; END

	GOTO	Asmend
; 'XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX   SUBROITINES    XXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXXX


; ROMBASE 01H                     ' start of rom area for subroutines

	ORG	01H
; '......................................


Dly50ms	; Time delay of 50 milli sec


; DOCODE

        MOVLW   0x00     ; set W register to 0
        MOVWF    0x01    ; set TMR0 register to zero

; ENDCODE


Waitloop	;


; DOCODE

        MOVF 0x01, 0      ; move value of TMR0 register to W reg
        MOVWF Scratch   ; now move TMR0 value to variable Scratch

; ENDCODE


;     IF Scratch <> 180 THEN Waitloop   ' loop until time is up -> Endvalue is number of counts for time, time delay here

	MOVLW	180
	SUBWF	Scratch,0
	BTFSS	3,2
	GOTO	Waitloop


; RETURN

	RETLW	0
; '.....................................


Do1sec	;


;    Timecnt = 0     ' make sure time count is set to zero

	MOVLW	0
	MOVWF	Timecnt


;     FOR Timecnt = 0 TO 20       ' TO value X 50 ms gives delay multiplier

	MOVLW	0
	MOVWF	Timecnt
Elbl3


;         GOSUB Dly50ms

	CALL	Dly50ms


;     NEXT

	MOVLW	20
	SUBWF	Timecnt,0
	BTFSC	3,2
	GOTO	Elbl4
	INCF	Timecnt,1
	GOTO	Elbl3
Elbl4


; RETURN

	RETLW	0
; '................................


SetLo	; set output port to low state


;    PortG = 0000B

	MOVLW	0000B
	MOVWF	PortG


; RETURN

	RETLW	0
; '......................................


SetHi	; set output port to high state


;    PortG = 0100B

	MOVLW	0100B
	MOVWF	PortG


; RETURN

	RETLW	0
; '**********************************************


Asmend
	GOTO	Asmend
	END
